
from pathlib import Path
import ctypes

from ..lib.logger import logger



lib = None
try:
    lib = ctypes.CDLL(str(Path(__file__).parents[1] / 'clib' / 'integrate.so'))

    # FFHS integrand
    lib.ffhsSD.restype = ctypes.c_double
    lib.ffhsSD.argtypes = (ctypes.c_double, ctypes.c_void_p)

    # Log-Gaussian integrands
    lib.logGaussianSD_high.restype = ctypes.c_double
    lib.logGaussianSD_high.argtypes = (ctypes.c_double, ctypes.c_void_p)
    lib.logGaussianSD_low.restype = ctypes.c_double
    lib.logGaussianSD_low.argtypes = (ctypes.c_double, ctypes.c_void_p)

    HAS_C_FUNCS = True
    logger.info('Use C functions')
except OSError:
    HAS_C_FUNCS = False
    logger.info('Use python functions')